<template>
  <div id="home">
    <b-container fluid="md">
    <b-jumbotron style="background:transparent !important">
      <b-container fluid="md">
          <b-form-input class="textColor" id="userNameInput" size="m" v-model="userName" placeholder="Enter your username"></b-form-input>
          <b-button class="nextButton mb-2" variant="success" v-on:click="findGame('success')">Find game(s)</b-button>
          <b-container>
            <b-row >
              <b-col class="margin" v-for="game in games" v-bind:key="game._id" md="auto" lg="4">
                <game-item v-bind:game="game" v-on:del-game="deleteGame(game)" v-on:start-game="startGame(game)"/>
              </b-col>
            </b-row>
          </b-container>
          <b-button v-show="loggedIn" class=nextButton v-b-modal.modal-1>Delete all games</b-button>
            <b-modal id="modal-1" title="Delete all games? Really?" @ok="resetUser">
                <p class="my-4">Are you sure?</p>
            </b-modal>
          <b-form-input class="textColor" v-show="loggedIn"  size="m" v-model="textGameName" placeholder="Enter name of the new game to" cols="12" sm="6" md="1"></b-form-input>
          <div v-show="loggedIn">
            <b-form-group label="categories" v-slot="{ ariaDescribedby }">
              <b-form-radio-group
                v-model="category"
                :options="options"
                :aria-describedby="ariaDescribedby"
                name="radio-inline"
              ></b-form-radio-group>
            </b-form-group>
          </div>
          <b-button class="nextButton mb-2" v-show="loggedIn" variant="success" v-on:click="newGame('success')">New Game</b-button>
      </b-container>
    </b-jumbotron>
    </b-container>
  </div>
</template>

<script>
// @ is an alias to /src
import { Api } from '@/Api'
import GameItem from '../components/GameItem.vue'

export default {
  name: 'games',
  components: {
    'game-item': GameItem
  },
  methods: {
    findGame(variant = null) {
      if (this.userName === 'deleteAllGames' || this.userName === 'Philip Leitner') { // only for the purpose of check 5.2.c
        this.loggedIn = false
        Api.delete('/games')
          .then(response => {
            this.deletedGames = response.data
            variant = 'danger'
            this.$bvToast.toast('ALL GAMES GONE OH MY GOD PHILIP WHY WOULD YOU DO THAT', {
              title: `Variant ${variant || 'default'}`,
              variant: variant,
              solid: true
            })
          })
          .catch(error => {
            this.message = error
          })
        return
      }
      if (this.userName === 'GetAllGames') { // only for the purpose of check 5.2.b
        this.loggedIn = false
        Api.get('/games')
          .then(response => {
            this.games = response.data
            variant = 'danger'
            this.$bvToast.toast('ALL GAMES IS SHOWN FOR JUST YOU', {
              title: `Variant ${variant || 'default'}`,
              variant: variant,
              solid: true
            })
          })
          .catch(error => {
            this.message = error
          })
        return
      }
      if (this.userName === '') {
        this.games = []
        this.nameTyped = false
        this.loggedIn = false
        variant = 'danger'
        this.$bvToast.toast('User name  must have at least one charachter', {
          title: `Variant ${variant || 'default'}`,
          variant: variant,
          solid: true
        })
        return
      }
      this.loggedIn = true
      Api.get(`/users/names/${this.userName}`)
        .then(response => {
          this.userID = response.data._id
          if (response.data === '') {
            this.games = []
            variant = 'success'
            this.$bvToast.toast('User created', {
              title: `Variant ${variant || 'default'}`,
              variant: variant,
              solid: true
            })
            const newUser = {
              username: this.userName
            }
            Api.post('/users', newUser)
              .then(response => {
                this.userID = response.data._id
              })
              .catch(error => {
                console.log(error)
              })
          } else {
            this.userID = response.data._id
            Api.get(`/users/${response.data._id}/games`)
              .then(response => {
                this.games = response.data.games
                if (response.data.games.length <= 0) {
                  this.games = []
                  this.nameTyped = false
                  variant = 'danger'
                  this.$bvToast.toast('Username does not have any games, please create a new game ', {
                    title: `Variant ${variant || 'default'}`,
                    variant: variant,
                    solid: true
                  })
                  this.games = ''
                  return
                }
                this.nameTyped = true
              })
              .catch(error => {
                this.message = error
              })
          }
          this.games = response.data.games
        })
    },
    newGame(variant = null) {
      const newGame = {
        gameName: this.textGameName,
        categories: this.category
      }
      if (this.userName === '') {
        variant = 'danger'
        this.$bvToast.toast('Username must have at least one character ', {
          title: `Variant ${variant || 'default'}`,
          variant: variant,
          solid: true
        })
        return
      }
      const gamename = this.textGameName
      if (gamename === '') {
        variant = 'danger'
        this.$bvToast.toast('Game must have a name', {
          title: `Variant ${variant || 'default'}`,
          variant: variant,
          solid: true
        })
        return
      }
      Api.post('/games', newGame)
        .then(response => {
          this.games = response.data
          this.$store.state.newGame = response.data
          const modifiedUser = {
            games: [response.data._id]
          }
          Api.patch(`/users/${this.userID}`, modifiedUser)
            .then(response => {
              this.updatedUser = response.data
            })
        })
        .catch(error => {
          console.log(error)
        })

      variant = 'success'
      this.$bvToast.toast('Created: ' + this.textGameName + ': user: ' + this.userName + ': category: ' + this.category, {
        title: `Variant ${variant || 'default'}`,
        variant: variant,
        solid: true
      })
      this.$router.push('prepare')
    },
    startGame(game) {
      this.$store.state.newGame = game
      this.$router.push('prepare')
    },
    deleteGame(game) {
      const gameID = game._id
      Api.delete(`/games/${gameID}`)
        .then(response => {
          const index = this.games.findIndex(game => game._id === gameID)
          this.games.splice(index, 1)
          this.deletedGame = response.data
          Api.delete(`/users/${this.userID}/games/${gameID}`)
            .then(response => {
              this.updatedUser = response.data
            })
        })
    },
    resetUser() {
      if (this.userName !== '') {
        const deleteGames = {
          username: this.userName,
          games: []
        }
        Api.put(`/users/${this.userID}`, deleteGames)
          .then(response => {
            this.updatedUser = response.data
            this.games = []
          })
      } else {
        const variant = 'danger'
        this.$bvToast.toast('Username must have at least one character', {
          title: `Variant ${variant || 'default'}`,
          variant: variant,
          solid: true
        })
      }
    }
  },
  data() {
    return {
      games: [],
      userID: '',
      updatedUser: '',
      deletedGame: '',
      newGames: '',
      theNewGame: '',
      userName: '',
      textGameName: '',
      checkBoxName: '',
      category: 'Fun',
      nameTyped: false,
      loggedIn: false,
      reqBody: '',
      deletedGames: '',
      options: [
        { text: 'Fun', value: 'Fun' },
        { text: 'Crazy', value: 'Crazy' },
        { text: 'Bar', value: 'Bar' },
        { text: 'Couple-edition', value: 'Couple-edition' }
      ]
    }
  }
}
</script>

<style scoped>
.btn_message {
  margin-bottom: 20em;
  color:aqua
}
.jumbotron{
  background-color: #7dc2af;
  color: white;
}
.form-field{
  width: 100%;
  padding: 12px 20px;
  margin: 8px 0;
  display: inline-block;
  border: 1px solid rgb(216, 209, 209);
  border-radius: 4px;
  box-sizing: border-box;
}
.smallTextBox {
  width: 10px;
  height: 10px;
}
.nextButton{
  color: white;
  background-color: #c48d9d!important;
  border-radius:7px!important;
  border-collapse: initial;
  padding: 2px 4px 2px 4px;
  transition: 0.4s;
  border: white!important;
  margin-top: 4px;
}
.textColor {
  color: black;
  background: white;
  border: white;
}
[type='checkbox'] {
    margin: 30px 30px 30px 30px;
  }
</style>
